<template>
  <vs-tabs class="p-4">
    <vs-tab
      label="Dự án"
      :class="[
        {
          'bg-highlight': activeManageTool
        },
        'mt-2'
      ]"
    >
      <template>
        <v-nav-menu-tab
          :items="projectList"
          :activeManageTool="activeManageTool"
          @edit="onClickEditProject"
          @delete="onClickDeleteProject"
        >
          <div
            v-if="!projectList.length"
            class="text-center"
            style="margin-top: 100px;"
          >
            <img
              src="@/assets/images/elements/empty-folder.png"
              alt="graphic-404"
              class="mx-auto mb-4 w-1/3 opacity-75"
            />
            <div>Chưa có dự án.</div>
          </div>
          <div class="bottom-container">
            <vs-button
              type="line"
              icon-pack="feather"
              icon="icon-plus"
              line-position="top"
              line-origin="left"
              color="primary"
              class="w-full"
              @click="onClickAddNewProject"
            >
              Thêm Dự án</vs-button
            >
            <feather-icon
              icon="ToolIcon"
              :svgClasses="
                `w-5 h-5 cursor-pointer hover:text-primary  ${
                  activeManageTool ? 'text-primary' : 'text-grey'
                }`
              "
              class="ml-5"
              href.prevent
              @click="activeManageTool = !activeManageTool"
            />
          </div>
        </v-nav-menu-tab>
      </template>
    </vs-tab>
    <vs-tab
      label="Thẻ"
      :class="[
        {
          'bg-highlight': activeManageTool
        },
        'mt-2'
      ]"
    >
      <v-nav-menu-tab
        :items="labelList"
        :activeManageTool="activeManageTool"
        @edit="onClickEditLabel"
        @delete="onClickDeleteLabel"
      >
        <div
          v-if="!labelList.length"
          class="text-center"
          style="margin-top: 100px;"
        >
          <img
            src="@/assets/images/elements/empty-folder.png"
            alt="graphic-404"
            class="mx-auto mb-4 w-1/3 opacity-75"
          />
          <div>Chưa có thẻ.</div>
        </div>
        <div class="bottom-container">
          <vs-button
            type="line"
            icon-pack="feather"
            icon="icon-plus"
            line-position="top"
            line-origin="left"
            color="primary"
            class="w-full"
            @click="onClickAddNewLabel"
          >
            Thêm Thẻ
          </vs-button>
          <feather-icon
            icon="ToolIcon"
            svgClasses="w-5 h-5 text-grey cursor-pointer hover:text-primary"
            class="ml-5"
            href.prevent
            @click="activeManageTool = !activeManageTool"
          />
        </div>
      </v-nav-menu-tab>
    </vs-tab>
    <vs-tab label="Bộ lọc">
      <v-nav-menu-tab :items="filterList" />
    </vs-tab>
  </vs-tabs>
</template>

<script>
import VNavMenuTab from "./VerticalNavMenuTab.vue";
import { todoLabelColor } from "../../../core/utils/color";
import { toVietnameseName } from "../../../core/utils/string";
import ProjectAddNew from "../../../presentations/project/ProjectAddNew";
import LabelAddNew from "../../../presentations/label/LabelAddNew";
import ProjectEdit from "../../../presentations/project/ProjectEdit";
import LabelEdit from "../../../presentations/label/LabelEdit";
import ProjectService from "../../../services/ProjectService";
import LabelService from "../../../services/LabelService";

export default {
  name: "v-nav-nemy-tabs",

  components: {
    VNavMenuTab
  },

  props: {
    projects: { type: Array, default: () => [] },
    labels: { type: Array, default: () => [] },
    filters: { type: Array, default: () => [] }
  },

  data() {
    return {
      activeManageTool: false
    };
  },

  computed: {
    projectList() {
      return this.buildProjectDisplayList();
    },

    labelList() {
      return this.buildLabelDisplayList();
    },

    filterList() {
      return this.buildFilterDisplayList();
    }
  },

  methods: {
    buildProjectDisplayList() {
      return this.projects.map(function(item) {
        const icon = "fiber_manual_record";
        const featherIcon = false;
        const textIcon = false;
        const name = item.name;
        const color = todoLabelColor(item.color).color;
        const url = `/todo/${item._id}`;
        const slug = `project-item-detail-view`;

        return {
          icon,
          featherIcon,
          textIcon,
          name,
          color,
          url,
          slug,
          info: item
        };
      });
    },

    buildLabelDisplayList() {
      return this.labels.map(function(item) {
        const icon = "local_offer";
        const featherIcon = false;
        const textIcon = false;
        const name = toVietnameseName(item.name);
        const color = "rgb(128, 128, 128)";
        const url = `/todo/${item._id}`;
        const slug = `label-item-detail-view`;
        const info = item;

        return { icon, featherIcon, textIcon, name, color, url, slug, info };
      });
    },

    buildFilterDisplayList() {
      return this.filters.map(function(item) {
        const icon = item.icon;
        const featherIcon = true;
        const textIcon = item.textIcon != null && item.textIcon == true;
        const name = item.name;
        const color = todoLabelColor(item.color).color;
        const url = `/todo/${item.id}`;
        const slug = `filter-item-detail-view`;
        const info = item;

        return { icon, featherIcon, textIcon, name, color, url, slug, info };
      });
    },

    async onClickAddNewProject() {
      try {
        await this.$showModal(ProjectAddNew, {}, { width: 450 });
      } catch (error) {
        console.log(error);
      }
    },

    async onClickAddNewLabel() {
      try {
        await this.$showModal(LabelAddNew, {}, { width: 450 });
      } catch (error) {
        console.log(error);
      }
    },

    async onClickEditProject(item) {
      try {
        await this.$showModal(ProjectEdit, { info: item }, { width: 450 });
      } catch (error) {
        console.log(error);
      }
    },

    async onClickEditLabel(item) {
      try {
        await this.$showModal(LabelEdit, { info: item }, { width: 450 });
      } catch (error) {
        console.log(error);
      }
    },

    async onClickDeleteProject(item) {
      const yes = await this.$confirm({
        text: "Bạn có chắc chắn muốn xóa dự án này không?"
      });
      if (!yes) return;

      try {
        const res = await ProjectService.delete(item._id);
        this.$success(res.message);

        // Fetch Project
        this.$store.dispatch("todo/fetchProjects");
      } catch (error) {
        this.$error(error.message);
      }
    },

    async onClickDeleteLabel(item) {
      const yes = await this.$confirm({
        text: "Bạn có chắc chắn muốn xóa thẻ này không?"
      });
      if (!yes) return;

      try {
        const res = await LabelService.delete(item._id);
        this.$success(res.message);

        // Fetch Tags
        this.$store.dispatch("todo/fetchTags");
      } catch (error) {
        this.$error(error.message);
      }
    }
  }
};
</script>

<style lang="scss">
@import "@/assets/scss/vuexy/components/verticalNavMenu.scss";
</style>
